# -*- coding: UTF-8 -*-

import time
import logging

from django.core.management.base import BaseCommand

# Import from crma
from crma.management.mailer import Mailer

logger = logging.getLogger(__name__)


# EMAIL SCAN FREQUENCY
SCAN_EVERY = 30


class Command(BaseCommand):
    def add_arguments(self, parser):
        super().add_arguments(parser)
        parser.add_argument('--debug',
                            action='store_true',
                            dest='debug',
                            default=False,
                            )

    def handle(self, *args, **options):
        debug = options['debug']
        mailer = Mailer(debug)

        try:
            while True:
                mailer()
                # SLEEP
                time.sleep(SCAN_EVERY)
        except (KeyboardInterrupt, SystemExit):
            return
        except Exception:
            logger.exception('Uncaught exception')
