# -*- coding: utf-8 -*-

import pytest
import django

from django.core.management import call_command

from crma.models import Subscription


@pytest.mark.usefixtures('db')
@pytest.mark.xfail(django.VERSION < (1, 9), reason='django <= 1.8 rewrites redirections as absolute url')
def test_unsubscribe_view(client):
    call_command('loaddata', 'crma/tests/views.yaml')
    r = client.get('/unsubscribe/oxf1s23owp2/', follow=False)
    assert r.status_code == 302
    assert r['Location'] == '/unsubscribe/completed/'

    s = Subscription.objects.get(pk=1)
    assert not s.is_active


@pytest.mark.usefixtures('db')
def test_unsubscribe_view_empty(client):
    call_command('loaddata', 'crma/tests/views.yaml')
    r = client.get('/unsubscribe/o_f1s23owp2/', follow=False)
    assert r.status_code == 404


@pytest.mark.usefixtures('db')
def test_view_webmail(client):
    call_command('loaddata', 'crma/tests/views.yaml')
    r = client.get('/viewmail/1-0eb8d2a9afc655e64cec62c91cde0bda/', follow=False)
    assert r.status_code == 200


@pytest.mark.usefixtures('db')
def test_view_webmail_bad_code(client):
    call_command('loaddata', 'crma/tests/views.yaml')
    r = client.get('/viewmail/1-0eb8d2a9afc655e64cec62c91cde0bdb/', follow=False)
    assert r.status_code == 404
